diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-enb-rrc.h ns-3.36/src/lte/model/lte-enb-rrc.h
--- ns-3.35/src/lte/model/lte-enb-rrc.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-enb-rrc.h	2022-04-30 18:23:58.042734400 -0700
@@ -108,8 +108,6 @@
    * \param rnti RNTI of the UE
    * \param s initial state of the UeManager
    * \param componentCarrierId primary component carrier ID
-   * 
-   * \return 
    */
   UeManager (Ptr<LteEnbRrc> rrc, uint16_t rnti, State s, uint8_t componentCarrierId);
 
@@ -210,6 +208,7 @@
   LteRrcSap::RadioResourceConfigDedicated GetRadioResourceConfigForHandoverPreparationInfo ();
 
   /** 
+   * \param componentCarrierId target component carrier ID
    * 
    * \return retrieve the data that the target eNB needs to send to the source
    * eNB as the Handover Command in the X2-based handover
@@ -218,7 +217,7 @@
    * \note mobility control info is not expected to be filled in
    * (shall be filled in by the caller). 
    */
-  LteRrcSap::RrcConnectionReconfiguration GetRrcConnectionReconfigurationForHandover ();
+  LteRrcSap::RrcConnectionReconfiguration GetRrcConnectionReconfigurationForHandover (uint8_t componentCarrierId);
 
   /**
    * Send a data packet over the appropriate Data Radio Bearer.
@@ -431,7 +430,7 @@
    * \return an NonCriticalExtensionConfiguration struct built based on the
    * current configuration
    */
-  LteRrcSap::NonCriticalExtensionConfiguration BuildNonCriticalExtentionConfigurationCa ();
+  LteRrcSap::NonCriticalExtensionConfiguration BuildNonCriticalExtensionConfigurationCa ();
 
   /** 
    * 
@@ -880,16 +879,16 @@
   /**
    * \brief Add a new UE measurement reporting configuration
    * \param config the new reporting configuration
-   * \return the measurement ID (measId) referring to the newly added
+   * \return the measurement IDs (measId) referring to the newly added
    *         reporting configuration
    *
    * Assuming intra-frequency environment, the new measurement reporting
-   * configuration will be automatically associated to the only measurement
-   * object (i.e., a new measurement identity will be automatically created).
+   * configuration will be automatically associated to measurement
+   * objects corresponding to serving cell frequencies.
    *
    * Can only be called before the start of simulation.
    */
-  uint8_t AddUeMeasReportConfig (LteRrcSap::ReportConfigEutra config);
+  std::vector<uint8_t> AddUeMeasReportConfig (LteRrcSap::ReportConfigEutra config);
 
   /**
    * \brief Configure cell-specific parameters.
@@ -954,6 +953,12 @@
    */
   uint16_t ComponentCarrierToCellId (uint8_t componentCarrierId);
 
+  /**
+   * \param cellId cell ID
+   * \return true if cellId is served by this eNB
+   */
+  bool HasCellId (uint16_t cellId) const;
+
   /** 
    * Enqueue an IP data packet on the proper bearer for downlink
    * transmission. Normally expected to be called by the NetDevice
@@ -1269,7 +1274,7 @@
    * \param reportConfig LteRrcSap::ReportConfigEutra
    * \returns measure ID
    */
-  uint8_t DoAddUeMeasReportConfigForHandover (LteRrcSap::ReportConfigEutra reportConfig);
+  std::vector<uint8_t> DoAddUeMeasReportConfigForHandover (LteRrcSap::ReportConfigEutra reportConfig);
   /**
    * Add UE measure report config for component carrier function
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ffr-distributed-algorithm.cc ns-3.36/src/lte/model/lte-ffr-distributed-algorithm.cc
--- ns-3.35/src/lte/model/lte-ffr-distributed-algorithm.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ffr-distributed-algorithm.cc	2022-04-30 18:23:58.042734400 -0700
@@ -389,8 +389,8 @@
 {
   NS_LOG_FUNCTION (this << rnti << (uint16_t) measResults.measId);
   NS_LOG_INFO ("CellId: " << m_cellId << " RNTI :" << rnti << " MeasId: " << (uint16_t) measResults.measId
-                          << " RSRP: " << (uint16_t)measResults.rsrpResult
-                          << " RSRQ: " << (uint16_t)measResults.rsrqResult);
+                          << " RSRP: " << (uint16_t)measResults.measResultPCell.rsrpResult
+                          << " RSRQ: " << (uint16_t)measResults.measResultPCell.rsrqResult);
 
   if (measResults.measId == m_rsrqMeasId)
     {
@@ -402,7 +402,7 @@
         }
 
       it = m_ues.find (rnti);
-      if (measResults.rsrqResult >= m_edgeSubBandRsrqThreshold)
+      if (measResults.measResultPCell.rsrqResult >= m_edgeSubBandRsrqThreshold)
         {
           if (it->second != CenterArea)
             {
@@ -435,7 +435,7 @@
           m_ues.insert (std::pair< uint16_t, uint8_t > (rnti, AreaUnset));
         }
 
-      UpdateNeighbourMeasurements (rnti, m_cellId, measResults.rsrpResult, measResults.rsrqResult);
+      UpdateNeighbourMeasurements (rnti, m_cellId, measResults.measResultPCell.rsrpResult, measResults.measResultPCell.rsrqResult);
 
       if (measResults.haveMeasResultNeighCells
           && !measResults.measResultListEutra.empty ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ffr-enhanced-algorithm.cc ns-3.36/src/lte/model/lte-ffr-enhanced-algorithm.cc
--- ns-3.35/src/lte/model/lte-ffr-enhanced-algorithm.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ffr-enhanced-algorithm.cc	2022-04-30 18:23:58.042734400 -0700
@@ -48,7 +48,7 @@
   uint8_t cellId; ///< cell ID
   uint8_t dlBandwidth; ///< DL bandwidth
   uint8_t dlSubBandOffset; ///< DL subband offset
-  uint8_t dlReuse3SubBandwidth; ///< reuse 3 subbandwidth 
+  uint8_t dlReuse3SubBandwidth; ///< reuse 3 subbandwidth
   uint8_t dlReuse1SubBandwidth; ///< reuse 1 subbandwidth
 } g_ffrEnhancedDownlinkDefaultConfiguration[] = {
   { 1, 25, 0, 4, 4},
@@ -695,7 +695,7 @@
             }
           NS_LOG_INFO (this << " RNTI " << rnti << " RBG  " << i << " DL-CQI: " << (int)rbgCqi);
 
-          bool rbgAvailable = (rbgCqi > m_dlCqiThreshold) ? true : false;
+          bool rbgAvailable = (rbgCqi > m_dlCqiThreshold);
 
           bool isSecondarySegmentRbg = false;
           if (i < m_dlSecondarySegmentRbgMap.size ())
@@ -861,8 +861,8 @@
 {
   NS_LOG_FUNCTION (this << rnti << (uint16_t) measResults.measId);
   NS_LOG_INFO ("RNTI :" << rnti << " MeasId: " << (uint16_t) measResults.measId
-                        << " RSRP: " << (uint16_t)measResults.rsrpResult
-                        << " RSRQ: " << (uint16_t)measResults.rsrqResult);
+                        << " RSRP: " << (uint16_t)measResults.measResultPCell.rsrpResult
+                        << " RSRQ: " << (uint16_t)measResults.measResultPCell.rsrqResult);
 
   if (measResults.measId != m_measId)
     {
@@ -877,7 +877,7 @@
         }
 
       it = m_ues.find (rnti);
-      if (measResults.rsrqResult < m_rsrqThreshold)
+      if (measResults.measResultPCell.rsrqResult < m_rsrqThreshold)
         {
           if (it->second != EdgeArea)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ffr-soft-algorithm.cc ns-3.36/src/lte/model/lte-ffr-soft-algorithm.cc
--- ns-3.35/src/lte/model/lte-ffr-soft-algorithm.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ffr-soft-algorithm.cc	2022-04-30 18:23:58.042734400 -0700
@@ -629,8 +629,8 @@
 {
   NS_LOG_FUNCTION (this << rnti << (uint16_t) measResults.measId);
   NS_LOG_INFO ("RNTI :" << rnti << " MeasId: " << (uint16_t) measResults.measId
-                        << " RSRP: " << (uint16_t)measResults.rsrpResult
-                        << " RSRQ: " << (uint16_t)measResults.rsrqResult);
+                        << " RSRP: " << (uint16_t)measResults.measResultPCell.rsrpResult
+                        << " RSRQ: " << (uint16_t)measResults.measResultPCell.rsrqResult);
 
   NS_ASSERT_MSG (m_centerSubBandThreshold >= m_edgeSubBandThreshold,
                  "CenterSubBandThreshold must be higher than EdgeSubBandThreshold");
@@ -649,7 +649,7 @@
         }
 
       it = m_ues.find (rnti);
-      if (measResults.rsrqResult >= m_centerSubBandThreshold)
+      if (measResults.measResultPCell.rsrqResult >= m_centerSubBandThreshold)
         {
           if (it->second != CenterArea)
             {
@@ -661,7 +661,7 @@
               m_ffrRrcSapUser->SetPdschConfigDedicated (rnti, pdschConfigDedicated);
             }
         }
-      else if (measResults.rsrqResult < m_edgeSubBandThreshold)
+      else if (measResults.measResultPCell.rsrqResult < m_edgeSubBandThreshold)
         {
           if (it->second != EdgeArea )
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-fr-soft-algorithm.cc ns-3.36/src/lte/model/lte-fr-soft-algorithm.cc
--- ns-3.35/src/lte/model/lte-fr-soft-algorithm.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-fr-soft-algorithm.cc	2022-04-30 18:23:58.042734400 -0700
@@ -511,8 +511,8 @@
 {
   NS_LOG_FUNCTION (this << rnti << (uint16_t) measResults.measId);
   NS_LOG_INFO ("RNTI :" << rnti << " MeasId: " << (uint16_t) measResults.measId
-                        << " RSRP: " << (uint16_t)measResults.rsrpResult
-                        << " RSRQ: " << (uint16_t)measResults.rsrqResult);
+                        << " RSRP: " << (uint16_t)measResults.measResultPCell.rsrpResult
+                        << " RSRQ: " << (uint16_t)measResults.measResultPCell.rsrqResult);
 
   if (measResults.measId != m_measId)
     {
@@ -527,7 +527,7 @@
         }
       it = m_ues.find (rnti);
 
-      if (measResults.rsrqResult < m_edgeSubBandThreshold)
+      if (measResults.measResultPCell.rsrqResult < m_edgeSubBandThreshold)
         {
           if (it->second != CellEdge)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-fr-strict-algorithm.cc ns-3.36/src/lte/model/lte-fr-strict-algorithm.cc
--- ns-3.35/src/lte/model/lte-fr-strict-algorithm.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-fr-strict-algorithm.cc	2022-04-30 18:23:58.042734400 -0700
@@ -522,8 +522,8 @@
 {
   NS_LOG_FUNCTION (this << rnti << (uint16_t) measResults.measId);
   NS_LOG_INFO ("RNTI :" << rnti << " MeasId: " << (uint16_t) measResults.measId
-                        << " RSRP: " << (uint16_t)measResults.rsrpResult
-                        << " RSRQ: " << (uint16_t)measResults.rsrqResult);
+                        << " RSRP: " << (uint16_t)measResults.measResultPCell.rsrpResult
+                        << " RSRQ: " << (uint16_t)measResults.measResultPCell.rsrqResult);
 
   if (measResults.measId != m_measId)
     {
@@ -538,7 +538,7 @@
         }
       it = m_ues.find (rnti);
 
-      if (measResults.rsrqResult < m_edgeSubBandThreshold)
+      if (measResults.measResultPCell.rsrqResult < m_edgeSubBandThreshold)
         {
           if (it->second != CellEdge )
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-handover-management-sap.h ns-3.36/src/lte/model/lte-handover-management-sap.h
--- ns-3.35/src/lte/model/lte-handover-management-sap.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-handover-management-sap.h	2022-04-30 18:23:58.042734400 -0700
@@ -73,7 +73,7 @@
    * \brief Request a certain reporting configuration to be fulfilled by the UEs
    *        attached to the eNodeB entity.
    * \param reportConfig the UE measurement reporting configuration
-   * \return the measurement identity associated with this newly added
+   * \return the measurement identities associated with this newly added
    *         reporting configuration
    *
    * The eNodeB RRC entity is expected to configure the same reporting
@@ -85,7 +85,7 @@
    *
    * \note This function is only valid before the simulation begins.
    */
-  virtual uint8_t AddUeMeasReportConfigForHandover (LteRrcSap::ReportConfigEutra reportConfig) = 0;
+  virtual std::vector<uint8_t> AddUeMeasReportConfigForHandover (LteRrcSap::ReportConfigEutra reportConfig) = 0;
 
   /**
    * \brief Instruct the eNodeB RRC entity to prepare a handover.
@@ -165,7 +165,7 @@
   MemberLteHandoverManagementSapUser (C* owner);
 
   // inherited from LteHandoverManagementSapUser
-  virtual uint8_t AddUeMeasReportConfigForHandover (LteRrcSap::ReportConfigEutra reportConfig);
+  virtual std::vector<uint8_t> AddUeMeasReportConfigForHandover (LteRrcSap::ReportConfigEutra reportConfig);
   virtual void TriggerHandover (uint16_t rnti, uint16_t targetCellId);
 
 private:
@@ -183,7 +183,7 @@
 
 
 template <class C>
-uint8_t
+std::vector<uint8_t>
 MemberLteHandoverManagementSapUser<C>::AddUeMeasReportConfigForHandover (LteRrcSap::ReportConfigEutra reportConfig)
 {
   return m_owner->DoAddUeMeasReportConfigForHandover (reportConfig);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-rlc-am.cc ns-3.36/src/lte/model/lte-rlc-am.cc
--- ns-3.35/src/lte/model/lte-rlc-am.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-rlc-am.cc	2022-04-30 18:23:58.042734400 -0700
@@ -442,7 +442,6 @@
   // Build Data field
   uint32_t nextSegmentSize = txOpParams.bytes - 4;
   uint32_t nextSegmentId = 1;
-  uint32_t dataFieldTotalSize = 0;
   uint32_t dataFieldAddedSize = 0;
   std::vector < Ptr<Packet> > dataField;
 
@@ -540,7 +539,6 @@
 
           // Add Segment to Data field
           dataFieldAddedSize = newSegment->GetSize ();
-          dataFieldTotalSize += dataFieldAddedSize;
           dataField.push_back (newSegment);
           newSegment = 0;
 
@@ -563,7 +561,6 @@
 
           // Add txBuffer.FirstBuffer to DataField
           dataFieldAddedSize = firstSegment->GetSize ();
-          dataFieldTotalSize += dataFieldAddedSize;
           dataField.push_back (firstSegment);
           firstSegment = 0;
 
@@ -593,7 +590,6 @@
           NS_LOG_LOGIC ("    IF firstSegment < NextSegmentSize && txonBuffer.size > 0");
           // Add txBuffer.FirstBuffer to DataField
           dataFieldAddedSize = firstSegment->GetSize ();
-          dataFieldTotalSize += dataFieldAddedSize;
           dataField.push_back (firstSegment);
 
           // ExtensionBit (Next_Segment - 1) = 1
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-rlc-am.h ns-3.36/src/lte/model/lte-rlc-am.h
--- ns-3.35/src/lte/model/lte-rlc-am.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-rlc-am.h	2022-04-30 18:23:58.042734400 -0700
@@ -135,7 +135,7 @@
   {
     Ptr<Packet> m_pdu; ///< PDU
     uint16_t    m_retxCount; ///< retransmit count
-    Time        m_waitingSince; ///!< Layer arrival time
+    Time        m_waitingSince; ///< Layer arrival time
   };
 
   std::vector <RetxPdu> m_txedBuffer;  ///< Buffer for transmitted and retransmitted PDUs 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-rlc-am-header.cc ns-3.36/src/lte/model/lte-rlc-am-header.cc
--- ns-3.35/src/lte/model/lte-rlc-am-header.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-rlc-am-header.cc	2022-04-30 18:23:58.042734400 -0700
@@ -72,12 +72,12 @@
 bool
 LteRlcAmHeader::IsDataPdu (void) const
 {
-  return (m_dataControlBit == DATA_PDU) ? true : false;
+  return m_dataControlBit == DATA_PDU;
 }
 bool
 LteRlcAmHeader::IsControlPdu (void) const
 {
-  return (m_dataControlBit == CONTROL_PDU) ? true : false;
+  return m_dataControlBit == CONTROL_PDU;
 }
 
 void
@@ -261,7 +261,7 @@
           return true;
         }
     }
-  return false;  
+  return false;
 }
 
 int
@@ -357,7 +357,7 @@
           it3++;
         }
 
- 
+
     }
 }
 
@@ -428,7 +428,7 @@
       // note: second part of ackSn will be written later
 
       // serialize the NACKs
-      if ( it3 == m_nackSnList.end () ) 
+      if ( it3 == m_nackSnList.end () )
         {
           NS_LOG_LOGIC (this << " no NACKs");
            // If there are no NACKs then this line adds the rest of the ACK
@@ -569,7 +569,7 @@
 
       if (m_resegmentationFlag == SEGMENT)
         {
-          m_lastOffset = m_segmentOffset + start.GetSize () - m_headerLength; 
+          m_lastOffset = m_segmentOffset + start.GetSize () - m_headerLength;
         }
     }
   else // if ( m_dataControlBit == CONTROL_PDU )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-rlc-um.cc ns-3.36/src/lte/model/lte-rlc-um.cc
--- ns-3.35/src/lte/model/lte-rlc-um.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-rlc-um.cc	2022-04-30 18:23:58.042734400 -0700
@@ -142,7 +142,6 @@
   // Build Data field
   uint32_t nextSegmentSize = txOpParams.bytes - 2;
   uint32_t nextSegmentId = 1;
-  uint32_t dataFieldTotalSize = 0;
   uint32_t dataFieldAddedSize = 0;
   std::vector < Ptr<Packet> > dataField;
 
@@ -241,7 +240,6 @@
 
           // Add Segment to Data field
           dataFieldAddedSize = newSegment->GetSize ();
-          dataFieldTotalSize += dataFieldAddedSize;
           dataField.push_back (newSegment);
           newSegment = 0;
 
@@ -263,7 +261,6 @@
           NS_LOG_LOGIC ("    IF nextSegmentSize - firstSegment->GetSize () <= 2 || txBuffer.size == 0");
           // Add txBuffer.FirstBuffer to DataField
           dataFieldAddedSize = firstSegment->GetSize ();
-          dataFieldTotalSize += dataFieldAddedSize;
           dataField.push_back (firstSegment);
           firstSegment = 0;
 
@@ -293,7 +290,6 @@
           NS_LOG_LOGIC ("    IF firstSegment < NextSegmentSize && txBuffer.size > 0");
           // Add txBuffer.FirstBuffer to DataField
           dataFieldAddedSize = firstSegment->GetSize ();
-          dataFieldTotalSize += dataFieldAddedSize;
           dataField.push_back (firstSegment);
 
           // ExtensionBit (Next_Segment - 1) = 1
